import 'package:regular_expressions_bot/weather/controller.dart';
import 'package:teledart/teledart.dart';
import 'package:teledart/telegram.dart';

void main() async {
  final botToken = '6628349220:AAHU2rx3ycmxraVLy99A2Kvhsp-7ZBsHBS0';
  final username = (await Telegram(botToken).getMe()).username;
  final teledart = TeleDart(botToken, Event(username!));

  teledart.onCommand('start').listen((message) {
    teledart.sendMessage(message.chat.id, 'Hello');
  });

  teledart
      .onMessage(keyword: WeatherController.weatherKeywordInEnglish)
      .listen((message) async {
    final controller = WeatherController();
    controller.setEnglishLanguage();

    if (message.text == null) {
      message.reply('Something wrong with message...');
      return;
    }

    if (!controller.detectDateTimeInEnglish(message.text!)) {
      message.reply('Unfortunately, it was not possible to recognize the date');
      return;
    }

    if (!controller.detectCityInEnglish(message.text!)) {
      message.reply(
        'Unfortunately, this city has not yet been added to the database',
      );
      return;
    }

    final weather = await controller.getWeather();

    if (weather == null) {
      message.reply(
        'Unfortunately, the API only allows you to look at the next 5 days',
      );
      return;
    }

    final result = weather.toString();

    message.reply(result);
  });

  teledart
      .onMessage(keyword: WeatherController.weatherKeywordInPolish)
      .listen((message) async {
    final controller = WeatherController();
    controller.setPolishLanguage();

    if (message.text == null) {
      message.reply('Coś nie tak z wiadomością...');
      return;
    }

    if (!controller.detectDateTimeInPolish(message.text!)) {
      message.reply('Niestety nie udało się odczytać daty');
      return;
    }

    if (!controller.detectCityInPolish(message.text!)) {
      message.reply('Niestety, to miasto nie zostało jeszcze dodane do bazy');
      return;
    }

    final weather = await controller.getWeather();

    if (weather == null) {
      message.reply(
        'Niestety API pozwala jedynie spojrzeć na najbliższe 5 dni',
      );
      return;
    }

    final result = weather.toString();

    message.reply(result);
  });

  teledart.start();
}
